#ifndef PROXIMITYDATAPROVIDER_H
#define PROXIMITYDATAPROVIDER_H

#include <QObject>
#include <QByteArray>

#include "../common/protocol/PTNP.h"
#include "../common/protocol/openbeacon.h"

//! Diese Klasse beschreibt abstrakt, wie Pakete empfangen werden sollen.
/*!
  Objekte abgeleiteter Klassen sollen Daten von jeweils einer verschiedenen Quellen holen
  und über ein gemeinsames Signal an den verarbeitenden Receiver weitergeben.
  */
class ProximityDataProvider : public QObject
{
    Q_OBJECT
public:
    ProximityDataProvider();
    ~ProximityDataProvider();
signals:
    //! Dieser Slot übergibt der behandelnden Methode das zu lesende ByteArray
    void readyRead(QByteArray*, bool);
protected slots:
    //! Diese Methode liest die Daten aus der Quelle ein und feuert \sa readyRead ab.
    virtual void readData() = 0;
};

#endif // PROXIMITYDATAPROVIDER_H
