#ifndef PROXIMITYLOGGER_H
#define PROXIMITYLOGGER_H

#include <QObject>
#include <QFile>
#include <QDateTime>

/*!
  Diese Klasse dient dem Mitschneiden des
  Paketdatenstroms, dass der ProximityServer
  empfängt.
  Dazu wird jedes Paket mit einem Zeitdifferenz-
  Stempel zum vorherigen Paket gespeichert.
  */
class ProximityLogger : public QObject
{
public:
    //! erstellt ein Objekt vom Typ ProximityLogger
    ProximityLogger();
    ~ProximityLogger();
    //! loggt das übergebene ByteArray mit Zeitdifferenz zum vorherigen Eintrag in die Logdatei
    void log(QByteArray);
    //! kreiert die Logdatei - gibt zurück, ob das fehlschlug (false) oder nicht (true)
    bool createLogFile();
private:

    QFile* logFile;
    QDateTime lastEntry;
};

#endif // PROXIMITYLOGGER_H
