#include "proximitynetworkdataprovider.h"

/*!
  Hier wird der Netzwerksocket initialisiert.
  */
ProximityNetworkDataProvider::ProximityNetworkDataProvider()
{
#ifdef _DEV_
    QTextStream cout(stdout, QIODevice::WriteOnly);
    cout<<"pndp.cpp: init ProximityNetworkDataProvider\n"<<flush;
#endif
    _socket = new QUdpSocket();
    connect(_socket, SIGNAL(readyRead()), this, SLOT(readData()));
    _socket->bind(QHostAddress::Any, UDP_LISTEN_PORT);
}

/*!
  Hier wird der socket gelöscht
  */
ProximityNetworkDataProvider::~ProximityNetworkDataProvider()
{
    if(_socket->isOpen()) {
        _socket->close();
    }
    delete _socket;
}

/*!
  Diese Methode holt sich die Daten aus dem Netz von den Antennen über UDP.
  */
void ProximityNetworkDataProvider::readData()
{
    QHostAddress host;
    quint16 port;
    if(_socket->hasPendingDatagrams()) {
            // weiß nicht, ob das nötig ist - wenn hier eh nur Bytes empfangen werden,
            // ist es auch nicht wirklich wichtig, dass die in der richtigen Reihenfolge sind, oder?
            // chain ist jedenfalls: datagram -> stream(BigEndian) -> hdatagram
            QByteArray* hdatagram = new QByteArray();
            QByteArray* datagram = new QByteArray();
            datagram->resize(sizeof(TBeaconEnvelope)+4); // +4 weil UDP am Anfang immer noch 4 Byte CRC-Summe mitschickt
            //datagram->resize(_socket->pendingDatagramSize()); // das hier ist nur für "ich weiß es ja doch nicht genau" :-)
            QDataStream stream(hdatagram, QIODevice::ReadWrite);
            stream.setByteOrder(QDataStream::BigEndian);

            _socket->readDatagram(datagram->data(), datagram->size()-4, &host, &port);
            stream.writeBytes(datagram->data(), datagram->size()-4);

            ip p;
            p.ip = host.toIPv4Address();
            for(int i=0; i<4; i++) {
                hdatagram->append(p.byte[i]);
            }
            //hdatagram->append(host.toIPv4Address()); // nun ist es ein TBeaconPackage
            hdatagram->remove(0,4); // die ersten 4 Byte eines UDP-Paketes sind nur CRC-Summe
#ifdef _DEV_
                    QTextStream cout(stdout, QIODevice::WriteOnly);
                    dec(cout)<<"pndp.cpp: daten: groesse: "<<hdatagram->count()<<" inhalt: "<<flush;
                    for(int i=0; i<hdatagram->count(); i++) {
                        dec(cout)<<(quint8)hdatagram->at(i)<<" "<<flush;
                    }
                    cout<<"\n"<<flush;
#endif
            emit readyRead(hdatagram, true);
            delete datagram;
    }
}
