#include "buttonevent.h"

namespace PTNP {
    /*!
      Dieser Konstruktor erzeugt ein ButtonEvent für ein Tag \a tag.
      Das TimeoutIntervall wird auf BUTTON_TIMEOUT Sekunden gesetzt
      */
    ButtonEvent::ButtonEvent(PTNP::ProximityTag* const tag) : tag_(tag)
    {
        this->setSingleShot(true);
        this->setInterval(BUTTON_TIMEOUT*MULTIPLIER);
    }

    /*!
      Diese Methode startet den Timeout neu
      */
    void ButtonEvent::stillPressed() {
        this->stop();
        //this->setInterval(1000);
        this->start();
    }
}
